function CleanUI_InitObjectiveTracker()
    CleanUIUserData.scaleObjectiveTracker = CleanUIUserData.scaleObjectiveTracker or 0.9;
    CleanUI_ScaleObjectiveTracker();

    CleanUI_RegisterObjectiveTrackerEvents();
end

function CleanUI_RegisterObjectiveTrackerEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("SCENARIO_UPDATE");

    frame:HookScript("OnEvent", CleanUI_ObjectiveTrackerOnEvent);
end

function CleanUI_ObjectiveTrackerOnEvent(self, event, ...)
    if ( event == "SCENARIO_UPDATE" ) then
        local newStage = ...;
        if ( newStage ) then
            CleanUI_ObjectiveTracker_Update(OBJECTIVE_TRACKER_UPDATE_SCENARIO_NEW_STAGE);
        else
            CleanUI_ObjectiveTracker_Update(OBJECTIVE_TRACKER_UPDATE_SCENARIO);
        end
    end
end

function CleanUI_ObjectiveTracker_Update(reason)
    if ( C_Scenario.IsInScenario() ) then

        local name, currentStage, numStages = C_Scenario.GetInfo();
        local name, description, numCriteria, stepFailed, isBonusStep, isForCurrentStepOnly, shouldShowBonusObjective = C_Scenario.GetStepInfo();

        --cui_debug("STATE", currentStage, "/", numStages);
        --cui_debug(" DESC", description);
    --[[
        				if ( currentStage == numStages ) then
							self.scenarioFrame.level:SetText(SCENARIO_STAGE_FINAL);
						else
							self.scenarioFrame.level:SetFormattedText(SCENARIO_STAGE, currentStage);
						end
    ]]
    end
end

function CleanUI_SetObjectiveTrackerScale(scale)
    if (scale and scale >= 0.5 and scale <= 2) then
        CleanUIUserData.scaleObjectiveTracker = scale;
        CleanUI_ScaleObjectiveTracker();
    else
        DEFAULT_CHAT_FRAME:AddMessage("scale: from 0.5 to 2.0", 1.0, 0, 0, 1, 10);
    end
end

function CleanUI_ScaleObjectiveTracker()    
    ObjectiveTrackerFrame:SetScale(CleanUIUserData.scaleObjectiveTracker);
end
