function CleanUI_InitWardrobe()
    CleanUI_RegisterWardrobeEvents();
end

function CleanUI_RegisterWardrobeEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");

    frame:HookScript("OnEvent", CleanUI_WardrobeOnEvent);
end

function CleanUI_WardrobeOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if (addonName == "Blizzard_Collections") then
            hooksecurefunc(WardrobeCollectionFrame.SetsCollectionFrame.ScrollFrame, "update", CleanUI_UpdateWardrobeSets);
            hooksecurefunc(WardrobeCollectionFrame.SetsCollectionFrame.ScrollFrame, "Update", CleanUI_UpdateWardrobeSets);
        end
    end
end


function CleanUI_UpdateWardrobeSets()
    local offset = HybridScrollFrame_GetOffset(WardrobeCollectionFrame.SetsCollectionFrame.ScrollFrame);
    local buttons = WardrobeCollectionFrame.SetsCollectionFrame.ScrollFrame.buttons;

    local SetsDataProvider = CreateFromMixins(WardrobeSetsDataProviderMixin);
    local baseSets = SetsDataProvider:GetBaseSets();
    
    for i = 1, #buttons do
		local button = buttons[i];
        local setIndex = i + offset;

        local setID = button.setID;

        local topSourcesCollected, topSourcesTotal = SetsDataProvider:GetSetSourceTopCounts(setID);
        local collected = C_TransmogSets.IsBaseSetCollected(setID);

        if (not button.expansionLogo) then
            button.expansionLogo = button:CreateTexture("LOW");
            button.expansionLogo:SetParent(button);
            button.expansionLogo:SetPoint("TOPLEFT", button, "TOPRIGHT", -85, -2);
            button.expansionLogo:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -5, 2);
            button.expansionLogo:SetAlpha(0.3);
        end

        local baseSet = baseSets[setIndex];

        if (baseSet) then
            local expansionID = baseSet.expansionID;
            local expansionDisplayInfo = GetExpansionDisplayInfo(expansionID);

            local label = baseSet.label or "unknown";
			button.Label:SetText(label.." ("..MAX_PLAYER_LEVEL_TABLE[expansionID]..")");
			button.Label:SetTextColor(1.0, 1.0, 1.0);

            if expansionDisplayInfo then
                button.expansionLogo:SetTexture(expansionDisplayInfo.logo);
                button.expansionLogo:Show();
            else
                button.expansionLogo:Hide();
            end
        end
    end
end